#include "gps.h"
#include "at91sam7x256.h"
#include "interrupt_utils.h"
#include "serial_us1.h"
#include "trace.h"
uint8_t NMEAStringReady;

uint8_t NMEAString[100]; // this will contain the last NMEA string from GPS 

void NAKEDFUNC Usart_c_irq_handler(void)
{
	ISR_ENTRY();
	
	usart0_putchar('B');
	unsigned int status;
	unsigned int val;
	//* get Usart status register
	status = *AT91C_US1_CSR;
	if ( status & AT91C_US_RXRDY)
	{
		//* Get byte and send
		usart0_putchar(*AT91C_US1_RHR);
	}

	if ( status & AT91C_US_OVRE) 
	{
		//* clear US_RXRDY
		usart0_putchar('O');
		*AT91C_US1_CR = (1 << AT91C_US_RSTSTA); // clear the Overrun interrupt
		 //val = *AT91C_US1_RHR;
		 
	}

	//* Check error
	if ( status & AT91C_US_PARE) 
	{
		usart0_putchar('P');
		*AT91C_US1_CR = (1 << AT91C_US_RSTSTA);
	}

	if ( status & AT91C_US_FRAME) 
	{
		usart0_putchar('F');
		*AT91C_US1_CR = (1 << AT91C_US_RSTSTA);
	}

	//* Reset the satus bit
	 //*AT91C_US1_CSR = AT91C_US_RSTSTA;
	 usart0_putchar('C');

	 ISR_EXIT();	 

}

